/**
 *	@file	DiaKbdMouseHook.h
 *	@brief	L[{[hŃ}EX삷邽߂̃L[̃tbNpDLL
 *	@auther	Masashi KITAMURA
 *	@date	2006
 *  @note
 *		t[\[X
 */
#ifndef DIAKBDMOUSEHOOK_H
#define DIAKBDMOUSEHOOK_H
#pragma once

#include <cassert>
#include <cstring>

#ifdef HOOKDLL_EXPORTS
#define HOOKDLL_API extern "C" __declspec(dllexport)
#else
#define HOOKDLL_API extern "C" __declspec(dllimport)
#endif

class CDiaKbdMouseHook_ConvKeyTbl;

/// tbN
HOOKDLL_API int 	 DiaKbdMouseHook_install(int keyCode, CDiaKbdMouseHook_ConvKeyTbl const& tbl);

/// tbN߂
HOOKDLL_API int 	 DiaKbdMouseHook_uninstall();

/// [h؂ւL[ݒ
HOOKDLL_API void	DiaKbdMouseHook_setModeKey(unsigned vkMode);

#ifdef USE_LWINKEY
/// WinL[ɂ}EXon/off
HOOKDLL_API	bool	DiaKbdMouseHook_setLWinMode(int sw);
#endif

/// pbhIɂ}EX{^̎擾
HOOKDLL_API unsigned DiaKbdMouseHook_mouseButton();

/// }EXL[̏
enum EDiaKbdMouse_Mouse {
	DIAKBDMOUSE_MOUSE_LEFT		= 0x0001,
	DIAKBDMOUSE_MOUSE_UP		= 0x0002,
	DIAKBDMOUSE_MOUSE_RIGHT		= 0x0004,
	DIAKBDMOUSE_MOUSE_DOWN		= 0x0008,
	DIAKBDMOUSE_MOUSE_LBUTTON	= 0x0010,
	DIAKBDMOUSE_MOUSE_RBUTTON	= 0x0020,
	DIAKBDMOUSE_MOUSE_MBUTTON	= 0x0040,
	DIAKBDMOUSE_MOUSE_XBUTTON1	= 0x0080,
	DIAKBDMOUSE_MOUSE_XBUTTON2	= 0x0100,
	DIAKBDMOUSE_MOUSE_WHEEL1	= 0x0200,
	DIAKBDMOUSE_MOUSE_WHEEL2	= 0x0400,
  #ifdef USE_LWINKEY
	DIAKBDMOUSE_MOUSE_MODEKEY	= 0x0800,		///< WingƂ̑΍
  #else
	DIAKBDMOUSE_MOUSE_SPEEDUP	= 0x0800,
  #endif
	DIAKBDMOUSE_MOUSE_SPEEDCHG	= 0x1000,
};



/// ϊe[up̌^
class CDiaKbdMouseHook_ConvKey {
public:
	///< [h
	enum EMode {
		MD_NONE		= 0,			///< gȂ
		MD_USE		= 1,			///< g
		MD_CTRL		= 2,			///< CTRLp
		MD_SHIFT	= 3,			///< SHIFTp
		MD_CTRLSHIFT= 4,			///< CTRL+SHIFTp
		MD_2ST_Q	= 5,			///< 2Xg[NL[̃gK[(Q)
		MD_EX_SHIFT = 6,			//x p~(J[\ړŃVtgp[h(͈͑Iz))
		MD_MOUSE	= 7,			///< }EX
	};
	class COne {
	public:
		unsigned char u8Mode_;		///< [h(EMode)
		unsigned char u8VkCode_;	///< ϊL[R[h
	};
	COne	oneKey_[2];				///< [0]=gL[݂̂̂Ƃ̃L[  [1]=2Xg[NL[(Q)Ƃp
};

class CDiaKbdMouseHook_ConvKeyTbl {
public:
	enum { MAX_SIZE = 256 };
	//CDiaKbdMouseHook_ConvKeyTbl() { std::memset(tbl_, 0, sizeof tbl_); }
	CDiaKbdMouseHook_ConvKey& operator[](unsigned n) { assert(n < MAX_SIZE); return tbl_[n]; }
	CDiaKbdMouseHook_ConvKey const& operator[](unsigned n) const { assert(n < MAX_SIZE); return tbl_[n]; }
	void	clear() { std::memset(tbl_, 0, sizeof tbl_); }
public:
	CDiaKbdMouseHook_ConvKey	tbl_[MAX_SIZE];
};

#endif
