/**
 *	@file	DiaKbdMouse.cpp
 *	@brief	L[{[hŃ}EX𐧌.
 *	@author	Masashi KITAMURA
 *	@date	2006
 *	@note
 *		t[\[X
 *		HACK HACK MORE HACK
 */

#include "stdafx.h"
#include "DiaKbdMouse.h"
#include <cstdlib>
#include <cstring>
#include "../cmn/DebugPrintf.h"
#include "../dll/DiaKbdMouseHook.h"
#include "KbdMouseCtrl.h"
#include "TrayIcon.h"
#include "ConfigFileReader.h"


/// L[{[hŃ}EX𐧌䂷AvENX.
class CDiaKbdMouseApp {
public:
	CDiaKbdMouseApp();
	// ~CDiaKbdMouseApp() {;}

	int winMain(HINSTANCE hInstance, HINSTANCE hPrevInstance, LPTSTR lpCmdLine, int nCmdShow);

private:
	ATOM			registerClass(HINSTANCE hInstance);
	bool			initInstance(HINSTANCE hInstance);

	static LRESULT CALLBACK wndProc(HWND, UINT, WPARAM, LPARAM);
	static LRESULT CALLBACK dlgProcAbout(HWND, UINT, WPARAM, LPARAM);

	DWORD			getConfigData(CDiaKbdMouseHook_ConvKeyTbl& tbl);
	LRESULT 		wmCreate (HWND hWnd, WPARAM wParam, LPARAM lParam);
	LRESULT 		wmCommand(HWND hWnd, WPARAM wParam, LPARAM lParam);
	LRESULT 		wmUserTrayIcon(HWND hWnd, LPARAM lParam);
	void			checkMenuItem(int id, bool checkSw /*, int dispSw*/);

	static void		setMinmumWorkingSetSize();

private:
	enum { MAX_LOADSTRING	= 100		  };
	enum { WM_USER_TRAYICON = WM_USER + 1 };

	HWND		hWnd_;
	HINSTANCE	hInstance_;						///< ݂̃C^[tFCX.
	HICON		hIconSm_;
	CTrayIcon	trayIcon_;
	TCHAR		szTitle_[MAX_LOADSTRING];		///< ^Cg o[̃eLXg.
	TCHAR		szWindowClass_[MAX_LOADSTRING];	///< C EBhE NX.
	//TCHAR		szIniName_[0x4000];				///< W[
	static CDiaKbdMouseApp*	s_pSelf_;			///< g̕ϐ(CX^X)ւ̃|C^
};

/// gւ̃|C^.
CDiaKbdMouseApp*	CDiaKbdMouseApp::s_pSelf_ = 0;


/** RXgN^
 */
CDiaKbdMouseApp::CDiaKbdMouseApp()
	: hWnd_(0)
	, hInstance_(0)
	, hIconSm_(0)
	, trayIcon_()
{
	std::memset(szTitle_      , 0, sizeof szTitle_);
	std::memset(szWindowClass_, 0, sizeof szWindowClass_);
	assert( s_pSelf_ == NULL );
	s_pSelf_ = this;
}


/** Gg.
 */
int CDiaKbdMouseApp::winMain(HINSTANCE /*hInstance0*/, HINSTANCE /*hPrevInstance*/, LPTSTR /*lpCmdLine*/, int /*nCmdShow*/)
{
	// WindowCX^X̎擾.
	HINSTANCE hInstance = ::GetModuleHandle(NULL);

	// \[X薼O擾.
	::LoadString(hInstance, IDS_APP_TITLE, szTitle_ 	 , MAX_LOADSTRING);
	::LoadString(hInstance, IDS_APP_NAME , szWindowClass_, MAX_LOADSTRING);

	// dNh~.
	::CreateMutex(NULL, 1, szWindowClass_);
	if (::GetLastError() == ERROR_ALREADY_EXISTS) {
		DEBUGPRINTF("dN\n");
		return -2;
	}

	// EBhE NXo^.
	registerClass(hInstance);

	// AvP[V̏.
	if (initInstance(hInstance/*, nCmdShow*/) == 0) {
		DEBUGPRINTF("NŎs\n");
		return -1;
	}

	// C bZ[W [v.
	HACCEL		hAccelTable;
	hAccelTable = ::LoadAccelerators(hInstance, (LPCTSTR)IDC_ACCELTABLE);
	MSG 		msg;
	while (::GetMessage(&msg, NULL, 0, 0)) {
		if (::TranslateAccelerator(msg.hwnd, hAccelTable, &msg) == 0) {
			::TranslateMessage(&msg);
			::DispatchMessage(&msg);
		}
		::Sleep(33);		// KɐQƂ.
	}

	// DLLI
	DiaKbdMouseHook_uninstall();

	return (int) msg.wParam;
}



///  EBhE NXo^.
///
ATOM CDiaKbdMouseApp::registerClass(HINSTANCE hInstance)
{
	WNDCLASSEX		wcex;
	wcex.cbSize			= sizeof(WNDCLASSEX);
	wcex.style			= CS_HREDRAW | CS_VREDRAW;
	wcex.lpfnWndProc	= (WNDPROC) wndProc;
	wcex.cbClsExtra		= 0;
	wcex.cbWndExtra		= 0;
	wcex.hInstance		= hInstance;
	wcex.hIcon			= ::LoadIcon(hInstance, (LPCTSTR) IDI_ICON);
	wcex.hCursor		= ::LoadCursor(NULL, IDC_ARROW);
	wcex.hbrBackground	= (HBRUSH) (COLOR_WINDOW + 1);
	wcex.lpszMenuName	= (LPCTSTR) IDC_MENU;
	wcex.lpszClassName	= szWindowClass_;
	wcex.hIconSm		= hIconSm_ = ::LoadIcon(wcex.hInstance, (LPCTSTR) IDI_SMALL);
	return ::RegisterClassEx(&wcex);
}


///	C vO EBhE쐬.
///
bool CDiaKbdMouseApp::initInstance(HINSTANCE hInstance /*, int nCmdShow*/)
{
	hInstance_	= hInstance;
	hWnd_		= ::CreateWindowEx(
						0/*dwExStyle*/,
						szWindowClass_,
						szTitle_,
						WS_CAPTION | /*WS_SYSMENU |*/ WS_POPUP,
						CW_USEDEFAULT,
						CW_USEDEFAULT,
						0,
						0,
						NULL,
						NULL,
						hInstance,
						NULL);

	if (hWnd_ == 0)
		return false;

	::ShowWindow(hWnd_, SW_HIDE/*nCmdShow*/);
	::UpdateWindow(hWnd_);

	return true;
}


/// C EBhẼbZ[W.
///
LRESULT CALLBACK CDiaKbdMouseApp::wndProc(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
	CDiaKbdMouseApp*	pSelf = s_pSelf_;
	assert( pSelf != 0 );
	switch (uMsg) {
	case WM_CREATE:
		return pSelf->wmCreate(hWnd, wParam, lParam);

	case WM_COMMAND:		// j[ڂ̏.
		if (pSelf->wmCommand(hWnd, wParam, lParam) == 0)
			return 0;
		break;

	case WM_USER_TRAYICON:	// gCACRŃNbNꂽƂ̏.
		return pSelf->wmUserTrayIcon(hWnd, lParam);

	case WM_DESTROY:
		// L[{[hŃ}EX삷鏈̃XbhI.
		CKbdMouseCtrl::release();
		// gCACȐI.
		pSelf->trayIcon_.release();
		// bZ[W[vI.
		::PostQuitMessage(0);
		return 0;

	default:
		pSelf->trayIcon_.checkRecreate(uMsg);	// ^XNo[č쐬ꂽACRēo^.
	}

	return ::DefWindowProc(hWnd, uMsg, wParam, lParam);
}


#if 1
DWORD	CDiaKbdMouseApp::getConfigData(CDiaKbdMouseHook_ConvKeyTbl& tbl)
{
	DWORD	dwKeyCode = 0;
	TCHAR	szIniName[0x4000];
	::GetModuleFileName(NULL, szIniName, 0x4000 );
	std::size_t l = ::lstrlen(szIniName);
	if (l > 4) {
		std::memcpy( &szIniName[l-3], _T("cfg"), 4 * sizeof(TCHAR) );	// gqcfg.
		//x DEBUGPRINTF("%s\n", path);
		CConfigFileReader	configData(szIniName, tbl);
		dwKeyCode	= configData.getData();
	}
	return dwKeyCode;
}
#else
DWORD getKeyCodeFromPrivateProfile()
{
	enum { EX_KEY = VK_APPS/*VK_RWIN*/ };
	DWORD	dwKeyCode = EX_KEY;
	TCHAR	szIniName[0x4000];
	::GetModuleFileName(NULL, szIniName, 0x4000 );
	std::size_t l = ::lstrlen(szIniName);
	if (l > 4) {
		std::::memcpy( &szIniName[l-3], _T("ini"), 4 * sizeof(TCHAR) );	// gqini.
		//x DEBUGPRINTF("%s\n", path);
		dwKeyCode = ::GetPrivateProfileInt(_T("COMMON"), _T("TRIGGER"), dwKeyCode, szIniName);
		if (dwKeyCode == 0)
			dwKeyCode = EX_KEY;
	}
	return dwKeyCode;
}
#endif


/// WM_CREATE ōs.
///
LRESULT CDiaKbdMouseApp::wmCreate(HWND hWnd, WPARAM /*wParam*/, LPARAM /*lParam*/)
{
	// gCɃACRo^.
	int rc = trayIcon_.create(
			WM_USER_TRAYICON,
			hInstance_,
			hWnd,
			hIconSm_,
			_T("DiaKbdMouse"),
			IDC_MENU
		);
	if (rc == 0) {		// gCACR̍쐬ɎsI.
		::DestroyWindow(hWnd);
		return 0;
	}

  #ifdef USE_LWINKEY
	// gCACRj[̏Ԃݒ
	checkMenuItem(IDM_LWIN_SW, DiaKbdMouseHook_setLWinMode(-1));
  #endif	

	// `t@Cǂݍ
 #if 1
	CDiaKbdMouseHook_ConvKeyTbl	tbl;
	tbl.clear();
	DWORD	dwKeyCode = getConfigData(tbl);	// VK_RWIN;	// VK_RMENU;
	if (dwKeyCode == 0) {	// `t@CŃG[ꍇ.
		::DestroyWindow(hWnd);
		return 0;
	}
	DiaKbdMouseHook_install(dwKeyCode, tbl);
 #else
	DWORD	dwKeyCode = getKeyCodeFromPrivateProfile();
	// DLLJn
	DiaKbdMouseHook_install(dwKeyCode);
 #endif

	// L[{[hŃ}EX삷鏈̃XbhN.
	CKbdMouseCtrl::create();

	// q[v̒
	setMinmumWorkingSetSize();
	return 0;
}


/// WM_COMMAND ōs.
///
LRESULT CDiaKbdMouseApp::wmCommand(HWND hWnd, WPARAM wParam, LPARAM /*lParam*/)
{
	DWORD wmId	  = LOWORD(wParam);
	//x DWORD wmEvent = HIWORD(wParam);
	// Iꂽj[̉
	switch (wmId) {
  #ifdef USE_LWINKEY
	case IDM_LWIN_SW:
		{
			bool sw = DiaKbdMouseHook_setLWinMode(-1);
			sw = (sw == 0);
			DiaKbdMouseHook_setLWinMode(sw);

			checkMenuItem(IDM_LWIN_SW, sw);
		}
		return 0;
  #endif

	case IDM_HELP:
		{
			TCHAR path[MAX_PATH+16]; // st@Ci[obt@
			::GetModuleFileName( NULL, path, MAX_PATH );
			std::size_t l = ::_tcslen(path);
			if (l > 4) {
				std::memcpy(&path[l-3], _T("htm"), 4*sizeof(TCHAR));	// gqhtmɂĂJƂɂ.
				//x DEBUGPRINTF("%s\n", path);
				::ShellExecute (hWnd, _T("open"), path, NULL, NULL, SW_SHOW);
				setMinmumWorkingSetSize();
			}
		}
		return 0;

	case IDM_ABOUT:
		::DialogBox(hInstance_, (LPCTSTR) IDD_ABOUTBOX, hWnd, (DLGPROC) dlgProcAbout);
		return 0;

	case IDM_EXIT:
		::DestroyWindow(hWnd);
		return 0;

	default:
		;
	}
	return 1;
}


/// j[ڂɃ`FbN}[N͂
///
void CDiaKbdMouseApp::checkMenuItem(int id, bool checkSw /*, int dispSw*/)
{
	int flags		= checkSw ? MFS_CHECKED : MFS_UNCHECKED;
	// HMENU	hMenu = ::GetSubMenu(::GetMenu(hWnd_), 0);
	HMENU	hMenu = trayIcon_.getMenuHandle();
	//x int checked =
	::CheckMenuItem(hMenu, id, MF_BYCOMMAND|flags);

	//x int dispFlags	= (dispMode < 0) ? MF_GLAY : (dispMode == 0) ? MF_DISABLE : MF_ENABLE;
	//x EnableMenuItem(hMenu, id, MF_BYCOMMAND|dispFlags);
}


/// ʒm̈̃ACRɑ΂đ삪sꂽꍇ.
///
LRESULT CDiaKbdMouseApp::wmUserTrayIcon(HWND hWnd, LPARAM lParam)
{
	switch (lParam) {
	case WM_RBUTTONDOWN:	// ENbN̂ƂA|bvAbvj[őI.
		{
			unsigned no = trayIcon_.trackPopupMenu();
			wmCommand(hWnd, no, lParam);
		}
		break;
	default:
		;
	}
	return 0;
}


/// o[W{bNX̃bZ[W nh.
///
LRESULT CALLBACK CDiaKbdMouseApp::dlgProcAbout(HWND hDlg, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
	lParam;
	switch (uMsg) {
	case WM_INITDIALOG:
		return TRUE;

	case WM_COMMAND:
		if (LOWORD(wParam) == IDOK || LOWORD(wParam) == IDCANCEL) {
			::EndDialog(hDlg, LOWORD(wParam));
			setMinmumWorkingSetSize();
			return TRUE;
		}
		break;

	default:
		;
	}
	return FALSE;
}


/// q[v̒
///
void CDiaKbdMouseApp::setMinmumWorkingSetSize()
{
	HINSTANCE hDll = ::LoadLibrary( _T( "kernel32.dll" ) );
	if ( hDll ) {
		typedef BOOL ( WINAPI *fn_t_SetProcessWorkingSetSize )( HANDLE, SIZE_T, SIZE_T );
		fn_t_SetProcessWorkingSetSize fn_SetProcessWorkingSetSize = reinterpret_cast< fn_t_SetProcessWorkingSetSize >( ::GetProcAddress( hDll, "SetProcessWorkingSetSize" ) );
		if ( fn_SetProcessWorkingSetSize ) {
			HANDLE hCurrentProcess = ::GetCurrentProcess();
		  #ifdef _WIN64
			fn_SetProcessWorkingSetSize(hCurrentProcess, 0xFFFFFFFFFFFFFFFFULL, 0xFFFFFFFFFFFFFFFFULL );
		  #else
			fn_SetProcessWorkingSetSize(hCurrentProcess, 0xFFFFFFFF, 0xFFFFFFFF );
		  #endif
		}
		::FreeLibrary( hDll );
	}
}



// ===========================================================================
/** NGg
 */
// ===========================================================================
int APIENTRY ::_tWinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance, LPTSTR lpCmdLine, int nCmdShow)
{
	CDiaKbdMouseApp		diaCursorApp;
	return diaCursorApp.winMain(hInstance, hPrevInstance, lpCmdLine, nCmdShow);
}
