/**
 *	@file	TrayIcon.cpp
 *	@brief	gC풓ACRpNX
 *	@author	Masashi KITAMURA
 *	@date	2006
 *	@note
 *		t[\[X
 */

#include "stdafx.h"
#include "TrayIcon.h"



/// src dst size-1 ͈̔͂ŃRs[Bdstɂ͕KŌ\0B
static inline const TCHAR* tcsCpyNum(TCHAR *dst, const TCHAR *src, unsigned size) {
	TCHAR*		d = dst;
	if (src && *src) {
		const TCHAR *e = dst+size;
		if (size)
			--e;
		const TCHAR * s = src;
		do {
			*d++ = *s++;
		} while ((*s != 0) & (d < e));
	}
	*d = _T('\0');
	return dst;
}


/** gCACR̍쐬
 */
bool CTrayIcon::create(unsigned uWm, HINSTANCE hInstance, HWND hWnd, HICON hIcon, const TCHAR* pTip, UINT uMenu)
{
	hInstance_							= hInstance;
	hWnd_								= hWnd;

	// ʒm̈̃ACR쐬
	notifyIconData_.cbSize 				= sizeof(NOTIFYICONDATA);
	notifyIconData_.hWnd 				= hWnd;
	notifyIconData_.uID 				= 0;
	notifyIconData_.uFlags 				= NIF_ICON | NIF_MESSAGE | NIF_TIP;
	notifyIconData_.uCallbackMessage 	= uWm;
	notifyIconData_.hIcon 				= hIcon;
	
	tcsCpyNum(notifyIconData_.szTip, pTip, sizeof(notifyIconData_.szTip));

	// ACRo^ł邩G[ɂȂ܂ŌJԂ
	while (::Shell_NotifyIcon(NIM_ADD, &notifyIconData_) == 0) {
		if (::GetLastError() != ERROR_TIMEOUT) {	// ^CAEgȊOȂ
			notifyIconData_.cbSize = 0;
			return false;	// ACRo^G[
		}
		// o^łĂȂƂmF
		if (::Shell_NotifyIcon(NIM_MODIFY, &notifyIconData_)) {
			// o^łĂ
			break;
		} else {
			// o^łĂȂ
			::Sleep(100);
		}
	}

	uWmTaskBarCreated_ = ::RegisterWindowMessage( _T("TaskbarCreated") );

	// Ńj[pӂĂ܂
	uMenuId_  = uMenu;
	hMenu_    = ::LoadMenu( hInstance_, MAKEINTRESOURCE( uMenu ) );
	hMenuSub_ = ::GetSubMenu( hMenu_, 0 );
	return true;
}



/** gCACR̊J
 */
void CTrayIcon::release()
{
	// ʒm̈̃ACR̍폜
	if (notifyIconData_.cbSize) {
		notifyIconData_.cbSize 	= sizeof(NOTIFYICONDATA);
		notifyIconData_.hWnd 	= hWnd_;
		notifyIconData_.uID 	= 0;
		notifyIconData_.uFlags 	= 0;
		::Shell_NotifyIcon(NIM_DELETE, &notifyIconData_);
		notifyIconData_.cbSize 	= 0;
	}
	::DestroyMenu(hMenu_);  //j[j
}



/** WndProc ɂăgC蒼̃EBhEbZ[W`FbNėĂč쐬
 */
void CTrayIcon::checkRecreate(UINT msg)
{
	if (msg == uWmTaskBarCreated_) {
		create(notifyIconData_.uCallbackMessage, hInstance_, hWnd_, notifyIconData_.hIcon, notifyIconData_.szTip, uMenuId_);
	}
}



/** ACRʒuŃ|bvAbvj[őIꂽAIDԂBȂ0ԂB
 */
UINT CTrayIcon::trackPopupMenu()
{
	// |bvAbvj[JOɃCEBhEANeBuɂ.
	::SetForegroundWindow(hWnd_);

	// |bvAbvj[J.
	POINT point;
	::GetCursorPos(&point);
	if (hMenuSub_ == NULL)
		return 0;

	UINT n = ::TrackPopupMenu(
					hMenuSub_,
					TPM_LEFTALIGN | TPM_LEFTBUTTON | TPM_RETURNCMD,
					point.x,
					point.y,
					0,
					hWnd_,
					NULL
				);
	return n;
}

