/**
 *	@file	TrayIcon.h
 *	@brief	gC풓ACRpNX
 *	@author	Masashi KITAMURA
 *	@date	2006
 *	@note
 *		t[\[X
 */
#ifndef TRAYICON_H
#define TRAYICON_H

#pragma once

#include <windows.h>


///	gC풓ACRpNX
class CTrayIcon {
public:
	CTrayIcon() { for (int i = sizeof *this; --i >= 0;) ((char*)this)[i] = '\0'; }	// @
	~CTrayIcon() { release(); }

	/// gCACR̍쐬
	bool create(unsigned uWm, HINSTANCE hInstance, HWND hWnd, HICON hIcon, const TCHAR* pTip, UINT uMenu);

	/// gCACR̊J
	void release();

	/// WndProc ɂăgC蒼̃EBhEbZ[W`FbNėĂč쐬
	void checkRecreate(UINT uMsg);

	/// ACRʒuŃ|bvAbvj[őIꂽAIDԂBȂ0ԂB
	UINT trackPopupMenu();

	/// ݂̃gCj[̃nhԂ
	const HMENU	getMenuHandle() const { return hMenuSub_; }

private:
	NOTIFYICONDATA 		notifyIconData_;			///< gCɂ̂ACR̂߂̏
	HINSTANCE			hInstance_;					///< CX^Xnh
	HWND				hWnd_;						///< EBhEEnh
	UINT 				uWmTaskBarCreated_;			///< ^XNo[ꂽɂEBhEnh
	HMENU				hMenu_;						///< gCj[̃nh
	HMENU				hMenuSub_;					///< gCj[̃Tuj[̃nh
	UINT				uMenuId_;					///< j[ID
};


#endif
